<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleChargePurposeType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfVehicleChargePurposeType extends AbstractStructArrayBase
{
    /**
     * The VehicleCharge
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgVehicleChargePurposeType[]
     */
    public $VehicleCharge;
    /**
     * Constructor method for ArrayOfVehicleChargePurposeType
     * @uses DgArrayOfVehicleChargePurposeType::setVehicleCharge()
     * @param \dgsoft\StructType\DgVehicleChargePurposeType[] $vehicleCharge
     */
    public function __construct(array $vehicleCharge = array())
    {
        $this
            ->setVehicleCharge($vehicleCharge);
    }
    /**
     * Get VehicleCharge value
     * @return \dgsoft\StructType\DgVehicleChargePurposeType[]|null
     */
    public function getVehicleCharge()
    {
        return $this->VehicleCharge;
    }
    /**
     * Set VehicleCharge value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleChargePurposeType[] $vehicleCharge
     * @return \dgsoft\ArrayType\DgArrayOfVehicleChargePurposeType
     */
    public function setVehicleCharge(array $vehicleCharge = array())
    {
        foreach ($vehicleCharge as $arrayOfVehicleChargePurposeTypeVehicleChargeItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleChargePurposeTypeVehicleChargeItem instanceof \dgsoft\StructType\DgVehicleChargePurposeType) {
                throw new \InvalidArgumentException(sprintf('The VehicleCharge property can only contain items of \dgsoft\StructType\DgVehicleChargePurposeType, "%s" given', is_object($arrayOfVehicleChargePurposeTypeVehicleChargeItem) ? get_class($arrayOfVehicleChargePurposeTypeVehicleChargeItem) : gettype($arrayOfVehicleChargePurposeTypeVehicleChargeItem)), __LINE__);
            }
        }
        $this->VehicleCharge = $vehicleCharge;
        return $this;
    }
    /**
     * Add item to VehicleCharge value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgVehicleChargePurposeType $item
     * @return \dgsoft\ArrayType\DgArrayOfVehicleChargePurposeType
     */
    public function addToVehicleCharge(\dgsoft\StructType\DgVehicleChargePurposeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgVehicleChargePurposeType) {
            throw new \InvalidArgumentException(sprintf('The VehicleCharge property can only contain items of \dgsoft\StructType\DgVehicleChargePurposeType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VehicleCharge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgVehicleChargePurposeType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgVehicleChargePurposeType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgVehicleChargePurposeType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgVehicleChargePurposeType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgVehicleChargePurposeType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleCharge
     */
    public function getAttributeName()
    {
        return 'VehicleCharge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfVehicleChargePurposeType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
